{ config, pkgs, lib, ... }:
let
  cfg = config.services.userdata;
in
{
  users.groups.acmerecievers = {
    members = [ "nginx" "dovecot2" "postfix" "virtualMail" "ocserv" ];
  };
  security.acme = {
    acceptTerms = true;
    email = "${cfg.username}@${cfg.domain}";
    certs = lib.mkForce {
      "${cfg.domain}" = {
        domain = "*.${cfg.domain}";
        extraDomainNames = [ "${cfg.domain}" ];
        group = "acmerecievers";
        dnsProvider = if cfg.dns.provider == "CLOUDFLARE" then "cloudflare" else abort "unknown DNS provider ${cfg.dns.provider}";
        credentialsFile = "/var/lib/cloudflare/Credentials.ini";
      };
      "meet.${cfg.domain}" = {
        domain = "meet.${cfg.domain}";
        group = "acmerecievers";
        dnsProvider = "cloudflare";
        credentialsFile = "/var/lib/cloudflare/Credentials.ini";
      };
    };
  };
}
